#D_Save_Master_Images.py ver.1.0
#2010/03/27	Detta
#マスターイメージを指定形式の画像で指定ディレクトリに書き出します。
#マスターイメージを選択（複数選択対応）した場合は選択されたマスターイメージを
#マスターイメージパートを選択した場合は、マスターイメージパート内のマスターイメージ全てを書き出します。
scene = xshade.scene()
shapes = scene.active_shapes
if len(shapes) == 1:
	img_list = []
	shape = shapes[0]
	if (shape.type == 2) and (shape.part_type == 102):
		if shape.has_son:
			st_ord = shape.son.bro.ordinal
			en_ord = shape.son.sis.ordinal
			for i in range(st_ord,en_ord+1):
				sp = scene.get_shape_by_ordinal(i)
				img_list.append(sp)
	elif shape.type == 10:
		img_list.append(shape)
else:
	for sp in shapes:
		if shape.type == 10:
			img_list.append(shape)
if img_list != []:
	dialog = xshade.create_dialog_with_uuid('69434ACF-A899-4C91-A6FD-E5BECA8159B4')
	id_path = dialog.append_path('folder',True,False)
	import sys
	if sys.platform == 'darwin':
		id_type = dialog.append_selection('type/png/tiff/bmp/jpg/gif/exr/pct/tga/raw/hdr/pfm/swf/psd')
	else:
		id_type = dialog.append_selection('type/bmp/jpg/gif/tiff/png/exr/tga/hdr/raw/pfm/swf/psd')
	if dialog.ask():
		f_path = dialog.get_value(id_path)
		f_type = dialog.get_value(id_type)
		if f_path != "":
			if sys.platform == 'darwin':
				ext =  ['.png', '.tiff', '.bmp', '.jpg', '.gif', '.exr', '.pct', '.tga', '.raw', '.hdr', '.pfm', '.swf', '.psd'][f_type]
			else:
				ext = ['.bmp', '.jpg', '.gif', '.tiff', '.png', '.exr', '.tga', '.hdr', '.raw', '.pfm', '.swf', '.psd'][f_type]
			import os
			for img in img_list:
				try:
					imgbody = os.path.splitext(img.name)[0]
					img_name = imgbody + ext
					save_path = os.path.join(f_path,img_name)
					img.save_image(save_path)
				except:
					print img_name + " Save Error"
else:
	xshade.show_message_box('マスターイメージパートか、マスターイメージを選択してください', False)
